Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/2370.html

2370. Longest Ideal Subsequence

  • Difficulty: Medium.
  • Related Topics: Hash Table, String, Dynamic Programming.
  • Similar Questions: Longest Increasing Subsequence.

Problem

You are given a string s consisting of lowercase letters and an integer k. We call a string t ideal if the following conditions are satisfied:

  • t is a subsequence of the string s.

  • The absolute difference in the alphabet order of every two adjacent letters in t is less than or equal to k.

Return the length of the **longest ideal string**.

A subsequence is a string that can be derived from another string by deleting some or no characters without changing the order of the remaining characters.

Note that the alphabet order is not cyclic. For example, the absolute difference in the alphabet order of 'a' and 'z' is 25, not 1.

  Example 1:

Input: s = "acfgbd", k = 2
Output: 4
Explanation: The longest ideal string is "acbd". The length of this string is 4, so 4 is returned.
Note that "acfgbd" is not ideal because 'c' and 'f' have a difference of 3 in alphabet order.

Example 2:

Input: s = "abcd", k = 3
Output: 4
Explanation: The longest ideal string is "abcd". The length of this string is 4, so 4 is returned.

  Constraints:

  • 1 <= s.length <= 105

  • 0 <= k <= 25

  • s consists of lowercase English letters.

Solution (Java, C++, Python)

  • class Solution {
        public int longestIdealString(String s, int k) {
            int ans = 1;
            int[] array = new int[26];
            for (int i = 0; i < s.length(); i++) {
                int curr = s.charAt(i) - 'a';
                int currans = 1;
                int temp = k;
                array[curr] += 1;
                int j = curr - 1;
                while (temp > 0) {
                    if (j == -1) {
                        break;
                    }
                    currans = Math.max(currans, array[j] + 1);
                    temp--;
                    if (j == 0) {
                        break;
                    }
                    j--;
                }
                temp = k;
                j = curr + 1;
                while (temp > 0) {
                    if (j == 26) {
                        break;
                    }
                    currans = Math.max(currans, array[j] + 1);
                    temp--;
                    if (j == 25) {
                        break;
                    }
                    j++;
                }
                array[curr] = Math.max(currans, array[curr]);
                ans = Math.max(ans, array[curr]);
            }
            return ans;
        }
    }
    
    ############
    
    class Solution {
        public int longestIdealString(String s, int k) {
            int n = s.length();
            int ans = 1;
            int[] dp = new int[n];
            Arrays.fill(dp, 1);
            Map<Character, Integer> d = new HashMap<>(26);
            d.put(s.charAt(0), 0);
            for (int i = 1; i < n; ++i) {
                char a = s.charAt(i);
                for (char b = 'a'; b <= 'z'; ++b) {
                    if (Math.abs(a - b) > k) {
                        continue;
                    }
                    if (d.containsKey(b)) {
                        dp[i] = Math.max(dp[i], dp[d.get(b)] + 1);
                    }
                }
                d.put(a, i);
                ans = Math.max(ans, dp[i]);
            }
            return ans;
        }
    }
    
  • class Solution:
        def longestIdealString(self, s: str, k: int) -> int:
            n = len(s)
            ans = 1
            dp = [1] * n
            d = {s[0]: 0}
            for i in range(1, n):
                a = ord(s[i])
                for b in ascii_lowercase:
                    if abs(a - ord(b)) > k:
                        continue
                    if b in d:
                        dp[i] = max(dp[i], dp[d[b]] + 1)
                d[s[i]] = i
            return max(dp)
    
    ############
    
    # 2370. Longest Ideal Subsequence
    # https://leetcode.com/problems/longest-ideal-subsequence/
    
    class Solution:
        def longestIdealString(self, s: str, k: int) -> int:
            dp = [0] * 26
            res = 0
            
            for x in s:
                v = ord(x) - ord("a")
                dp[v] += 1
                
                for z in range(max(0, v - k), min(25, v + k) + 1):
                    if v != z:
                        dp[v] = max(dp[v], dp[z] + 1)
                
                res = max(res, dp[v])
            
            return res
    
    
  • class Solution {
    public:
        int longestIdealString(string s, int k) {
            int n = s.size();
            int ans = 1;
            vector<int> dp(n, 1);
            unordered_map<char, int> d;
            d[s[0]] = 0;
            for (int i = 1; i < n; ++i) {
                char a = s[i];
                for (char b = 'a'; b <= 'z'; ++b) {
                    if (abs(a - b) > k) continue;
                    if (d.count(b)) dp[i] = max(dp[i], dp[d[b]] + 1);
                }
                d[a] = i;
                ans = max(ans, dp[i]);
            }
            return ans;
        }
    };
    
  • func longestIdealString(s string, k int) int {
    	n := len(s)
    	ans := 1
    	dp := make([]int, n)
    	for i := range dp {
    		dp[i] = 1
    	}
    	d := map[byte]int{s[0]: 0}
    	for i := 1; i < n; i++ {
    		a := s[i]
    		for b := byte('a'); b <= byte('z'); b++ {
    			if int(a)-int(b) > k || int(b)-int(a) > k {
    				continue
    			}
    			if v, ok := d[b]; ok {
    				dp[i] = max(dp[i], dp[v]+1)
    			}
    		}
    		d[a] = i
    		ans = max(ans, dp[i])
    	}
    	return ans
    }
    
    func max(a, b int) int {
    	if a > b {
    		return a
    	}
    	return b
    }
    
  • function longestIdealString(s: string, k: number): number {
        const dp = new Array(26).fill(0);
        for (const c of s) {
            const x = c.charCodeAt(0) - 'a'.charCodeAt(0);
            let t = 0;
            for (let i = 0; i < 26; i++) {
                if (Math.abs(x - i) <= k) {
                    t = Math.max(t, dp[i] + 1);
                }
            }
            dp[x] = Math.max(dp[x], t);
        }
    
        return dp.reduce((r, c) => Math.max(r, c), 0);
    }
    
    

Explain:

nope.

Complexity:

  • Time complexity : O(n).
  • Space complexity : O(n).

All Problems

All Solutions